#!/usr/bin/perl

use strict;
use CGI();

require "inc/cwcal.pl";

my $title2 = __("Configuration Wcal");
my $title = __("Thmes");
my $iconmsg = __("Changer l'icone");
my $reloadmsg = __("Rafrachir");
my $bgmsg = __("Changer le fond");
my $wconf = cw_get_wconf();
my $url = $wconf->{"base url"} || "/wcal";
my $theme;
my $www;

my $q = new CGI();

sub alert_code
{
    my $msg = shift;
    my $str = "<script language=javascript>\n";
    $str .= "<!--\n";
    $str .= "alert(\"$msg\");\n";
    $str .= "//-->\n";
    $str .= "</script>\n";
}

sub write_img
{
    my $id = shift;
    my $img = shift;
    my $filename = $q->param("imgfile");
    my $size;
    my $buffer;
    my $wcald = cw_get_wcald();
    open(FILE, ">$wcald->{DIRECTORY}/themes/$id/$img");
    while ($size = read($filename,$buffer,1024))
    {
        print FILE $buffer;
    }
    close(FILE);
}

sub delete_img
{
    my $id = shift;
    my $img = shift;
    my $wcald = cw_get_wcald();
    unlink("$wcald->{DIRECTORY}/themes/$id/$img");
}

sub icon_code
{
    my $icon = shift;
    if ($www)
    {
	return "<img border=0 src=\"$icon\" alt=\"$icon\" title=\"$icon\">";
    }
    elsif ($theme)
    {
	return "<a target=\"edit\" href=\"$ENV{SCRIPT_NAME}?edit=$theme->{id}&icon=$icon\"><img border=0 src=\"$url/$icon\" alt=\"$iconmsg ($icon)\" title=\"$iconmsg ($icon)\"></a>";
    }
    else
    {
	return "<img border=0 src=\"$url/$icon\" alt=\"$icon\" title=\"$icon\">";
    }
}

sub bg_code
{
    my $color = shift;
    if ($theme && !$www)
    {
	return "<a target=\"edit\" href=\"$ENV{SCRIPT_NAME}?edit=$theme->{id}&color=$color\"><img border=0 hspace=10 src=\"images/editbg.gif\" alt=\"$bgmsg ($color)\" title=\"$bgmsg ($color)\"></a>";
    }
    else
    {
	return "&nbsp;";
    }
}

if ($q->param("preview"))
{
    my $authname = "";
    my $authmail = "";

    $www = $q->param("preview") == 2;
    
    if (defined $q->param("theme"))
    {
	if ($q->param("theme"))
	{
	    $theme = cw_get_theme($q->param("theme"));
	}
    }
    else
    {
	if ($wconf->{theme})
	{
	    $theme = cw_get_theme($wconf->{theme});
	}
    }

    if ($theme)
    {
	$url .= "/themes/$theme->{id}";
	if ($theme->{author} =~ /\s*(.*\S)\s*<([^>]*)>/)
	{
	    $authname = $1;
	    $authmail = $2;
	}
	else
	{
	    $authname = $theme->{author};
	}
    }
    else
    {
	$url .= "/images";
    }

    cw_header($title, $www, $theme);
    print "<center>\n";
    if (!$www)
    {
	print "<h1><a href=\".\" target=\"_top\">$title2</a></h1>\n";
    }

    print "<table width=100% cellpadding=20 cellspacing=0 border=2>\n";
    print "<tr><td".cw_bgstr(8, $theme, $www).">\n";
    print "<table width=100% border=0 cellspacing=0><tr align=center>\n";
    print "<td width=20%>";
    print icon_code("group1.gif");
    print " ".__("Groupe ferm");
    print "</td>";
    print "<td width=20%>";
    print icon_code("group2.gif");
    print " ".__("Groupe ouvert");
    print "</td>";
    print "<td align=right width=60%>";
    print bg_code("back");
    print "</td>";
    print "</tr>";
    print "</table>";
    print "<table width=100% border=0 cellspacing=0><tr>\n";
    print "<td width=20%>";
    print icon_code("sync.gif");
    print"</td>\n";
    print "<td nowrap width=60% align=center>";
    print "<table><tr valign=center><td>";
    print icon_code("left-arrow.gif");
    print "</td>\n";
    print "<td><b>";
    print $theme ? $www ? $theme->{name} : "<a target=\"edit\" href=\"$ENV{SCRIPT_NAME}?edit=$theme->{id}&name=1\">$theme->{name}</a>" : "Wcal";
    print "</b></td>\n";
    print "<td>";
    print icon_code("right-arrow.gif");
    print "</td>\n";
    print "</tr>\n</table></td>";
    print "<td width=20% nowrap align=right>".__("par")." ";
    print $theme ? $www ? $authname : "<a target=\"edit\" href=\"$ENV{SCRIPT_NAME}?edit=$theme->{id}&author=1\">$authname</a>" : "Joel Savignon";
    if ($authmail)
    {
	print " <a href=\"mailto:$authmail\"><img border=0 src=\"$url/mail.gif\" alt=\"$authmail\" title=\"$authmail\"></a>";
    }
    print "</td>\n";
    print "</tr>\n</table>\n";
    print "<table width=100% border=2 cellspacing=0>\n";
    print "<tr align=center>\n";
    print "<td width=5".cw_bgstr(2, $theme, $www).">";
    print icon_code("reload.gif");
    print "</td>\n";
    print "<td width=25%".cw_bgstr(2, $theme, $www)."><b>";
    print __("Jour actif");
    print bg_code("th");
    print "</b></td>\n";
    print "<td width=25%".cw_bgstr(2, $theme, $www)."><b>";
    if ($theme && !$www)
    {
	print "<a target=\"edit\" href=\"$ENV{SCRIPT_NAME}?edit=$theme->{id}&text=1\">\n";
    }
    print __("Jour inactif");
    if ($theme && !$www)
    {
	print "</a>\n";
    }
    print "</b></td>\n";
    print "<td width=25%".cw_bgstr(7, $theme, $www)."><b>";
    print __("Jour courant");
    print bg_code("nowth");
    print "</b></td>\n";
    print "<td width=25%".cw_bgstr(6, $theme, $www)."><b>";
    print __("Jour fri");
    print "&nbsp;&nbsp;".icon_code("sday.gif");
    print "</b></td>\n";
    print "</tr>\n";
    print "<tr align=center>\n";
    print "<td width=5".cw_bgstr(2, $theme, $www).">";
    print icon_code("am.gif");
    print"</td>\n";
    print "<td width=25%".cw_bgstr(3, $theme, $www)."><b>";
    print bg_code("td1");
    print"</b></td>\n";
    print "<td width=25%".cw_bgstr(4, $theme, $www)."><b>";
    print bg_code("td2");
    print "</b></td>\n";
    print "<td width=25%".cw_bgstr(5, $theme, $www)."><b>";
    print bg_code("nowtd");
    print "</b></td>\n";
    print "<td width=25%".cw_bgstr(6, $theme, $www)."><b>";
    print bg_code("sdays");
    print "</b></td>\n";
    print "</tr>\n";
    print "<tr align=center>\n";
    print "<td width=5".cw_bgstr(2, $theme, $www).">";
    print icon_code("pm.gif");
    print "</td>\n";
    print "<td width=25%".cw_bgstr(3, $theme, $www)."><font size=2>";
    print __("Tche");
    print " ".icon_code("note.gif");
    print " ".icon_code("todo.gif");
    print " ".icon_code("mail.gif");
    print " ".icon_code("lock.gif");
    print " ".icon_code("priv.gif");
    print " ".icon_code("alarm.gif");
    print " ".icon_code("alarm2.gif");
    print "</font></td>\n";
    print "<td width=25%".cw_bgstr(4, $theme, $www)."><b>";
    print "&nbsp;";
    print "</b></td>\n";
    print "<td width=25%".cw_bgstr(5, $theme, $www)."><b>";
    print "&nbsp;";
    print "</b></td>\n";
    print "<td width=25%".cw_bgstr(6, $theme, $www)."><b>";
    print "&nbsp;";
    print "</b></td>\n";
    print "</tr>\n";
    print "<tr align=center>\n";
    print "<td width=5".cw_bgstr(2, $theme, $www).">";
    print icon_code("nt.gif");
    print "</td>\n";
    print "<td width=25%".cw_bgstr(3, $theme, $www)."><b>";
    print "&nbsp;";
    print "</b></td>\n";
    print "<td width=25%".cw_bgstr(4, $theme, $www)."><b>";
    print "&nbsp;";
    print "</b></td>\n";
    print "<td width=25%".cw_bgstr(5, $theme, $www)."><b>";
    print "&nbsp;";
    print "</b></td>\n";
    print "<td width=25%".cw_bgstr(6, $theme, $www)."><b>";
    print "&nbsp;";
    print "</b></td>\n";
    print "</tr>\n";
    print "</table>\n";
    print "</td>\n</tr>\n";
    print "<tr><td align=right".cw_bgstr(9, $theme, $www).">\n";
    print bg_code("mwd");
    print "<p>\n";
    if ($theme && $www)
    {
	print '<form action="'.$theme->{id}.'.tgz">'."\n";
    }
    else
    {
	print '<form method="post" target="_top" action="theme.cgi">'."\n";
    }
    print "<table border=2 width=100% cellpadding=5 cellspacing=0><tr align=center>\n";
    print "<td width=5".cw_bgstr(2, $theme, $www).">";
    if ($www)
    {
	print '<img src="reload.gif" border=0 alt="reload.gif" title="reload.gif"></a>';
    }
    else
    {
	print '<a href="" onclick="window.location.reload();return false;"><img src="'.$url.'/reload.gif" border=0 alt="'.$reloadmsg.'" title="'.$reloadmsg.'"></a>';
    }
    print "</td>\n";
    print "<td nowrap width=100%".cw_bgstr(2, $theme, $www)."><b>";
    print $theme ? $www ? $theme->{comment} : "<a target=\"edit\" href=\"$ENV{SCRIPT_NAME}?edit=$theme->{id}&comment=1\">$theme->{comment}</a>" : "Wcal default look";
    print "</b></td>\n";
    print "</tr>\n";
    print "<tr>\n";
    print "<td nowrap colspan=2 width=100%".cw_bgstr(1, $theme, $www).">\n";
    print "<table width=100%>\n";
    print "<tr>\n";
    print "<td>".bg_code("td")."</td>\n";
    print "<td align=right nowrap>";
    if ($www)
    {
	print __("ID");
    }
    else
    {
	print __("Nouvel ID");
    }
    print " :</td>\n";
    print "<td><input name=\"newid\" value=\"$theme->{id}\">\n";
    if ($theme && $theme->{id} && !$www)
    {
	print '<input type="submit" name="rename" value="'.__("Renommer").'">'."\n";
    }
    print "</td>\n";
    print "<td>&nbsp;</td>\n";
    print "<td>&nbsp;</td>\n";
    print "</tr>\n";
    print "<tr>\n";
    print "<td>&nbsp;</td>\n";
    print "<td align=right nowrap>";
    if ($www)
    {
	print __("Nom");
    }
    else
    {
	print __("Nouveau nom");
    }
    print " :</td>\n";
    print "<td><input name=\"newname\" value=\"$theme->{name}\"></td>\n";
    print "<td>&nbsp;</td>\n";
    print "<td>&nbsp;</td>\n";
    print "</tr>\n";
    print "<tr>\n";
    print "<td>&nbsp;</td>\n";
    print "<td align=right nowrap>";
    if ($www)
    {
	print __("Commentaire");
    }
    else
    {
	print __("Nouveau commentaire");
    }
    print " :</td>\n";
    print "<td><input name=\"newcomment\" size=40 value=\"$theme->{comment}\"></td>\n";
    print "<td>&nbsp;</td>\n";
    print "<td>&nbsp;</td>\n";
    print "</tr>\n";
    print "<tr>\n";
    print "<td colspan=5><hr></td>\n";
    print "</tr>\n";
    print "<tr>\n";
    print "<td>\n";
    if ($www)
    {
	print "&nbsp;";
    }
    else
    {
	print '<input type="submit" name="apply" value="'.__("Appliquer").'">'."\n";
    }
    print "</td>\n";
    print "<td>&nbsp;</td>\n";
    print "<td>\n";
    if ($www)
    {
	print '<input type="submit" name="download" value="'.__("Tlcharger").'">'."\n";
    }
    else
    {
	print '<input type="submit" name="duplicate" value="'.__("Dupliquer").'">'."\n";
    }
    print "</td>\n";
    print "<td align=right>\n";
    if ($theme && $theme->{id} && !$www)
    {
	print '<input type="submit" name="delete" value="'.__("Supprimer").'"';
	print ' onclick=\'return confirm("'.sprintf(__("Voulez-vous rellement supprimer le thme %s ?"), $theme->{id}).'")\'';
	print '>'."\n";
    }
    else
    {
	print "&nbsp;";
    }
    print "</td>\n";
    print "<td align=right>\n";
    if ($theme && $theme->{id} && !$www)
    {
	print '<input type="submit" name="export" value="'.__("Exporter").'">'."\n";
    }
    else
    {
	print "&nbsp;";
    }
    print "</td>\n";
    print "</tr>\n";
    print "</table>\n";
    print "</td>\n";
    print "</tr></table>\n";
    print '<input type="hidden" name="id" value="'.$theme->{id}.'">'."\n";
    print "</form>\n";
    print "</td></tr>\n";
    print "</table>\n";
    print "</center>\n";
    cw_footer();
}
elsif ($q->param("menu"))
{
    cw_header($title);
    print "<center>\n";
    print "<h1>$title</h1>";

    my %themes = cw_themes();
    my $id;
    my $theme;
    my $selected;
    if ($q->param("theme"))
    {
	$selected = $q->param("theme");
    }
    else
    {
	$selected = $wconf->{theme};
    }
    my $size = scalar(keys(%themes))+1;
    print "<script language=javascript>\n";
    print "<!--\n";
    print "function changeTheme(theme){\n";
    print "  top.preview.location.href = '$ENV{SCRIPT_NAME}?preview=1&theme='+theme.options[theme.selectedIndex].value;\n";
    print "  top.edit.location.href = '$ENV{SCRIPT_NAME}?edit=1&theme='+theme.options[theme.selectedIndex].value;\n";
    print "}\n";
    print "//-->\n";
    print "</script>\n";
    print "<form method=\"post\" target=\"edit\">\n";
    print '<select name="theme" size='.$size.' onchange="changeTheme(this)">'."\n";
    print '<option value=""';
    if (!$selected)
    {
	print " selected";
    }
    print '>'.__("Pas de thme");
    if (!$wconf->{theme})
    {
	print " *";
    }
    print "\n";
    foreach $id (sort {$themes{$a}->{name} cmp $themes{$b}->{name}} keys(%themes))
    {
	$theme = $themes{$id};
	print '<option value="'.$id.'"';
	if ($id eq $selected)
	{
	    print " selected";
	}
	print '>'.$theme->{name};
	if ($wconf->{theme} && $wconf->{theme} eq $id)
	{
	    print " *";
	}
	print "\n";
    }
    print "</select>\n";
    print "<p>\n";
    print '<input type="submit" name="more" value="'.__("Plus...").'">'."\n";
    print "</form>\n";
    print "</center>\n";
    cw_footer();
}
elsif ($q->param("edit"))
{
    cw_header($title);
    if ($q->param("edit") ne "1")
    {
	$theme = cw_get_theme($q->param("edit"));
	
	print '<form method="post" enctype="multipart/form-data" action="theme.cgi" target="_top">'."\n";
	print "<center>\n";
	print "<h2>".__("Editeur de thme")."</h2>\n";
	print "<table border=2 cellspacing=0 cellpadding=5>\n";
	if ($q->param("name") || $q->param("comment"))
	{
	    print "<tr>\n";
	    print "<td align=right>".__("Nom du thme")." :</td>\n";
	    print '<td><input name="name" value="'.$theme->{name}.'"></td>'."\n";
	    print "</tr>\n";
	    print "<tr>\n";
	    print "<td align=right>".__("Commentaire du thme")." :</td>\n";
	    print '<td><input size=40 name="comment" value="'.$theme->{comment}.'"></td>'."\n";
	    print "</tr>\n";
	}
	elsif ($q->param("author"))
	{
	    my $str = $theme->{author};
	    $str =~ s/\s*<[^>]*>//;
	    print "<tr>\n";
	    print "<td align=right>".__("Nom de l'auteur")." :</td>\n";
	    print '<td><input name="authname" value="'.$str.'"></td>'."\n";
	    print "</tr>\n";
	    if ($theme->{author} =~ /<([^>]*)>/)
	    {
		$str = $1;
	    }
	    else
	    {
		$str = "";
	    }
	    print "<tr>\n";
	    print "<td align=right>".__("Email de l'auteur")." :</td>\n";
	    print '<td><input size=40 name="authmail" value="'.$str.'"></td>'."\n";
	    print "</tr>\n";
	}	
	elsif ($q->param("icon"))
	{
	    print "<tr>\n";
	    print "<td align=right>";
	    $url .= "/themes/$theme->{id}";
	    print '<img align="middle" src="'.$url."/".$q->param("icon").'" border=0 alt="'.$q->param("icon").'" title="'.$q->param("icon").'"> ';
	    print __("Fichier image")." :</td>\n";
	    print '<td><input size=40 name="imgfile" type="file"><input name="icon" type="hidden" value="'.$q->param("icon").'"></td>'."\n";
	    print "</tr>\n";
	}
	elsif ($q->param("color"))
	{
	    $url .= "/themes/$theme->{id}";
	    print "<tr>\n";
	    print "<td rowspan=2";
	    my $bgimg = $theme->{$q->param("color")."bg"};
	    if ($bgimg)
	    {
		print ' background="'.$url.'/'.$bgimg.'"';
	    }
	    print ">";
	    print '<img src="images/editbg.gif" alt="'.$q->param("color").'" title="'.$q->param("color").'">&nbsp;';
	    print __("Image de fond")." : ";
	    print '<input type="radio" name="bg" value=1';
	    if ($bgimg)
	    {
		print " checked";
	    }
	    print '>';
	    print __("Oui");
	    print '&nbsp;<input type="radio" name="bg" value=0';
	    if (!$bgimg)
	    {
		print " checked";
	    }
	    print '>';
	    print __("Non");
	    print "</td>\n";
	    print "<td align=right";
	    if ($bgimg)
	    {
		print ' background="'.$url.'/'.$bgimg.'"';
	    }
	    print ">";
	    print __("Fichier image")." :</td>\n";
	    print '<td';
	    if ($bgimg)
	    {
		print ' background="'.$url.'/'.$bgimg.'"';
	    }
	    print '><input size=40 name="imgfile" type="file"><input name="color" type="hidden" value="'.$q->param("color").'"></td>'."\n";
	    print "</tr>\n";
	    print "<tr>\n";
	    print "<td align=right";
	    if ($theme->{$q->param("color")."color"})
	    {
		print ' bgcolor="'.$theme->{$q->param("color")."color"}.'"';
	    }
	    print ">";
	    print __("Couleur")." :</td>\n";
	    print '<td';
	    if ($theme->{$q->param("color")."color"})
	    {
		print ' bgcolor="'.$theme->{$q->param("color")."color"}.'"';
	    }
	    print '><input name="rgb" value="'.$theme->{$q->param("color")."color"}.'"</td>'."\n";
	    print "</tr>\n";
	}	
	elsif ($q->param("text"))
	{
	    print "<tr>\n";
	    print "<td align=right><font";
	    if ($theme->{textcolor})
	    {
		print " color=\"$theme->{textcolor}\"";
	    }
	    print ">";
	    print __("Texte")."</font> :</td>\n";
	    print '<td><input name="textcolor" value="'.$theme->{textcolor}.'"</td>'."\n";
	    print "<td align=right><font";
	    if ($theme->{vlinkcolor})
	    {
		print " color=\"$theme->{vlinkcolor}\"";
	    }
	    print "><u>";
	    print __("Liens visits")."</u></font> :</td>\n";
	    print '<td><input name="vlinkcolor" value="'.$theme->{vlinkcolor}.'"</td>'."\n";
	    print "</tr>\n";
	    print "<tr>\n";
	    print "<td align=right><font";
	    if ($theme->{linkcolor})
	    {
		print " color=\"$theme->{linkcolor}\"";
	    }
	    print "><u>";
	    print __("Liens")."</u></font> :</td>\n";
	    print '<td><input name="linkcolor" value="'.$theme->{linkcolor}.'"</td>'."\n";
	    print "<td align=right><font";
	    if ($theme->{alinkcolor})
	    {
		print " color=\"$theme->{alinkcolor}\"";
	    }
	    print "><u>";
	    print __("Liens actifs")."</u></font> :</td>\n";
	    print '<td><input name="alinkcolor" value="'.$theme->{alinkcolor}.'"</td>'."\n";
	    print "</tr>\n";
	}	
	print "</table>\n";
	print "<p>\n";
	print '<input type="submit" name="modify" value="'.__("Valider").'">'."\n";
	print '<input type="hidden" name="id" value="'.$theme->{id}.'">'."\n";
	print "</form>\n";
	print "</center>\n";
    }
    cw_footer();
}
elsif ($q->param("more"))
{
    cw_header($title);
    print '<form method="post" enctype="multipart/form-data" action="theme.cgi" target="_top">'."\n";
    print "<center>\n";
    print "<h2>".__("Plus de thmes")."</h2>\n";
    print "<table border=2 cellspacing=0 cellpadding=5>\n";
    print "<tr>\n";
    print "<td align=right>";
    print __("Fichier thme")." :</td>\n";
    print '<td><input size=40 name="thmfile" type="file">'."\n";
    print '<input type="submit" name="download" value="'.__("Tlcharger").'" onclick="window.open(\'http://www.neosystem.com/wcal/themes\');return false;">'."\n";
    print '</td>'."\n";
    print "</tr>\n";
    print "</table>\n";
    print "<p>\n";
    print '<input type="submit" name="import" value="'.__("Importer").'">'."\n";
    print "</form>\n";
    print "</center>\n";
    cw_footer();
}
else
{
    my $param = "";
    my $msg = "";
    if ($q->param("duplicate"))
    {
	if (!$q->param("newid") || $q->param("newid") =~ /\W/)
	{
	    $msg = __("ID invalide");
	    $param = "&theme=".$q->param("id");
	}
	elsif (!$q->param("newname") || $q->param("newname") =~ /\W/)
	{
	    $msg = __("Nom invalide");
	    $param = "&theme=".$q->param("id");
	}
	else
	{
	    $theme = cw_get_theme($q->param("newid"));
	    if ($theme)
	    {
		$msg = sprintf(__("Le thme %s existe dj"), $q->param("newid"));
		$param = "&theme=".$q->param("id");
	    }
	    else
	    {
		cw_duplicate_theme($q->param("id"), $q->param("newid"));
		if ($q->param("id"))
		{
		    $theme = cw_get_theme($q->param("newid"));
		}
		else
		{
		    $theme = {
			"author"        =>      "Joel Savignon",
			"backcolor"     =>      "#ffffff",
			"backbg"        =>      "background.jpg",
			"mwdcolor"      =>      "#ffffff",
			"mwdbg"         =>      "mwdbackground.jpg",
			"thcolor"       =>      "#e2e3fc",
			"tdcolor"       =>      "#d9f4f4",
			"td1color"      =>      "#f3f3fc",
			"td2color"      =>      "#fcf3f2",
			"nowthcolor"    =>      "#caffd0",
			"nowtdcolor"    =>      "#caffd0",
			"sdayscolor"    =>      "#e0e0e0",
		    };
		}
		$theme->{id} = $q->param("newid");
		$theme->{name} = $q->param("newname");
		$theme->{comment} = $q->param("newcomment");
		cw_write_theme($theme);
		$param = "&theme=".$q->param("newid");
	    }
	}
    }
    elsif ($q->param("modify"))
    {
	$url .= "/themes/".$q->param("id");
	if (defined $q->param("icon") && defined $q->param("imgfile"))
	{
	    write_img($q->param("id"), $q->param("icon"))
	}
	elsif (defined $q->param("color"))
	{
	    $theme = cw_get_theme($q->param("id"));
	    if ($q->param("rgb"))
	    {
		$theme->{$q->param("color")."color"} = $q->param("rgb");
	    }
	    else
	    {
		delete $theme->{$q->param("color")."color"};
	    }
	    if (!$q->param("bg") && $theme->{$q->param("color")."bg"})
	    {
		delete_img($q->param("id"), $theme->{$q->param("color")."bg"});
		delete $theme->{$q->param("color")."bg"};
	    }
	    elsif ($q->param("imgfile"))
	    {
		if ($theme->{$q->param("color")."bg"})
		{
		    delete_img($q->param("id"), $theme->{$q->param("color")."bg"});
		}
		my $filename = $q->param("color")."bg.jpg";
		write_img($q->param("id"), $filename);
		$theme->{$q->param("color")."bg"} = $filename;
	    }
	    cw_write_theme($theme);
	}
	else
	{
	    $theme = cw_get_theme($q->param("id"));
	    if (defined $q->param("name"))
	    {
		if ($q->param("name"))
		{
		    $theme->{name} = $q->param("name");
		}
		else
		{
		    $msg = __("Nom invalide");
		}
		$theme->{comment} = $q->param("comment");
	    }
	    elsif (defined $q->param("authname"))
	    {
		if ($q->param("authname"))
		{
		    $theme->{author} = $q->param("authname");
		    if ($q->param("authmail"))
		    {
			if ($q->param("authmail") =~ /^[^@]+@[^@]+$/)
			{
			    $theme->{author} .= " <".$q->param("authmail").">";
			}
			else
			{
			    $msg = __("Email invalide");
			}
		    }
		}
		else
		{
		    $msg = __("Auteur invalide");
		}
	    }
	    elsif (defined $q->param("textcolor"))
	    {
		if ($q->param("textcolor"))
		{
		    $theme->{textcolor} = $q->param("textcolor");
		}
		else
		{
		    delete  $theme->{textcolor};
		}
		if ($q->param("linkcolor"))
		{
		    $theme->{linkcolor} = $q->param("linkcolor");
		}
		else
		{
		    delete  $theme->{linkcolor};
		}
		if ($q->param("vlinkcolor"))
		{
		    $theme->{vlinkcolor} = $q->param("vlinkcolor");
		}
		else
		{
		    delete  $theme->{vlinkcolor};
		}
		if ($q->param("alinkcolor"))
		{
		    $theme->{alinkcolor} = $q->param("alinkcolor");
		}
		else
		{
		    delete  $theme->{alinkcolor};
		}
	    }
	    cw_write_theme($theme);
	}
	$param = "&theme=".$q->param("id");
    }
    elsif ($q->param("apply"))
    {
	if ($q->param("id"))
	{
	    $wconf->{theme} = $q->param("id");
	}
	else
	{
	    delete $wconf->{theme};
	}
	cw_write_conf($wconf);
	$msg = __("N'oubliez pas de relancer Wcal");
    }    
    elsif ($q->param("delete"))
    {
	cw_delete_theme($q->param("id"));
	if ($wconf->{theme} eq $q->param("id"))
	{
	    delete $wconf->{theme};
	    cw_write_conf($wconf);
	}
    }
    elsif ($q->param("export"))
    {
	cw_export_theme($q->param("id"));
	exit();
    }
    elsif ($q->param("import"))
    {
	my $filename = $q->param("thmfile");
	my $size;
	my $buffer;
	my $wcald = cw_get_wcald();
	open(FILE, ">$wcald->{DIRECTORY}/themes/new.tar.gz");
	while ($size = read($filename,$buffer,1024))
	{
	    print FILE $buffer;
	}
	close(FILE);
	open(CMD, "cd $wcald->{DIRECTORY}/themes; gzip -d new.tar.gz; tar tvf new.tar |");
	my $line = <CMD>;
	my @lines = <CMD>;
	close(CMD);
	my $id;
	@lines = split(/\s+/, $line);
	$line = pop @lines;
	if ($line =~ /^(\w+)\//)
	{
	    $id = $1;
	}
	if (!$id)
	{
	    $msg = __("Fichier thme invalide");
	}
	elsif (-e "$wcald->{DIRECTORY}/themes/$id")
	{
	    $msg = sprintf(__("Le thme %s existe dj"), $id);
	}
	else
	{
	    system("cd $wcald->{DIRECTORY}/themes; tar xvf new.tar > /dev/null");
	    $param = "&theme=".$id;
	}
	system("\\rm $wcald->{DIRECTORY}/themes/new.*");
    }
    elsif ($q->param("rename"))
    {
	if (!$q->param("newid") || $q->param("newid") =~ /\W/)
	{
	    $msg = __("ID invalide");
	    $param = "&theme=".$q->param("id");
	}
	else
	{
	    $theme = cw_get_theme($q->param("newid"));
	    if ($theme)
	    {
		$msg = sprintf(__("Le thme %s existe dj"), $q->param("newid"));
		$param = "&theme=".$q->param("id");
	    }
	    else
	    {
		$theme = cw_get_theme($q->param("id"));
		cw_rename_theme($q->param("id"), $q->param("newid"));
		$theme->{id} = $q->param("newid");
		cw_write_theme($theme);
		if ($wconf->{theme} eq $q->param("id"))
		{
		    $wconf->{theme} = $q->param("newid");
		    cw_write_conf($wconf);
		}
		$param = "&theme=".$q->param("newid");
	    }
	}
    }    

    print "Content-type: text/html\n\n";
    print "<title>$title</title>\n";
    if ($msg)
    {
	print alert_code($msg);
    }
    print '<frameset cols="25%,75%" border=0 framespacing=0>'."\n";
    print '<frame name="menu" src="'.$ENV{SCRIPT_NAME}.'?menu=1'.$param.'">'."\n";
    print '<frameset rows="75%,25%" border=0 framespacing=0>'."\n";
    print '<frame name="preview" src="'.$ENV{SCRIPT_NAME}.'?preview=1'.$param.'">'."\n";
    print '<frame name="edit" src="'.$ENV{SCRIPT_NAME}.'?edit=1'.$param.'">'."\n";
    print '</frameset>'."\n";
    print '</frameset>'."\n";
}
