#!/usr/bin/perl

use strict;
use CGI();

require "inc/cwcal.pl";

my $q = new CGI();

my $title2 = __("Configuration Wcal");
my $title = __("Utilisateurs et groupes");
my $title3 = __("Contrle d'accs");

cw_header($title);

print "<center>\n";
print "<h1><a href=\".\">$title2</a></h1>\n";
print "</center>\n";
print "<h2><a href=\"usgr.cgi\">$title</a></h2>\n";

my $wconf = cw_get_wconf();
my $uconf = cw_get_uconf();
my $gconf = cw_get_gconf();
my $conf_ref;
my $user;
my $group;
my $title4;
my $param;
my $wctype;
my $wcid;

if ($q->param("user"))
{
    $user = $q->param("user");
    $conf_ref = $uconf->{$user};
    if ($uconf->{$user}->{"data id"})
    {
	my $alt = $uconf->{$uconf->{$user}->{'data id'}}->{'long name'};
	my $gr = $uconf->{$uconf->{$user}->{'data id'}}->{group};
	while ($gr)
	{
	    $alt = "$gconf->{$gr}->{'long name'} / $alt";
	    $group = $gconf->{$gr}->{group};
	}
	if ($uconf->{$user}->{'read only'} eq "true")
	{
	    $alt = "R : $alt";
	}
	$alt = cw_unquote($alt);
	$title4 = '<img src="images/mail.gif" alt="'.$alt.'" title="'.$alt.'"> '.sprintf(__("Lien %s"), $user);
    }
    else
    {
	$title4 = '<img src="images/user.gif" alt="'.$uconf->{$user}->{"long name"}.'" title="'.$uconf->{$user}->{"long name"}.'"> '.sprintf(__("Utilisateur %s"), $user);
    }
    $param="user=$user";
    $wctype = "user";
    $wcid = $user;
}
elsif ($q->param("group"))
{
    $group = $q->param("group");
    $conf_ref = $gconf->{$group};
    $title4 = '<img src="images/group1.gif" alt="'.$gconf->{$group}->{"long name"}.'" title="'.$gconf->{$group}->{"long name"}.'"> '.sprintf(__("Groupe %s"), $group);
    $param="group=$group";
    $wctype = "group";
    $wcid = $group;
}
else
{
    $conf_ref = $wconf;
    $title4 = "Wcal";
    $param="";
}
my $sep = "";
my $str = "";
my $grp;
my $cref = $conf_ref;
while ($grp = $conf_ref->{group})
{
    $str = '<a href="access.cgi?group='.$grp.'"><img src="images/group1.gif" border=0 alt="'.$grp.'" title="'.$grp.'"></a> '.$gconf->{$grp}->{"long name"}.$sep.$str;
    $sep = " / ";
    $conf_ref = $gconf->{$grp};
}
if ($str)
{
    print "<h3>$str</h3>\n";
}

if ($q->param("enable"))
{
    $cref->{"access file"} = cw_tmpl_access($wctype, $wcid);
}
elsif ($q->param("disable"))
{
    delete $cref->{"access file"};
}
elsif ($q->param("access file") || $q->param("delaccess"))
{
    if ($q->param("delaccess"))
    {
	delete $cref->{"access file"};
    }
    else
    {
	$cref->{"access file"} = $q->param("access file");
	$cref->{"access file"} =~ s/\r//mg;
    }
    if ($user)
    {
	cw_write_uconf($user, $cref);
	print '<font color="#00aa00" size=4>'.__("Configuration utilisateur modifie")."</font>\n";
    }
    elsif ($group)
    {
	cw_write_gconf($group, $cref);
	print '<font color="#00aa00" size=4>'.__("Configuration groupe modifie")."</font>\n";
    }
    else
    {
	cw_write_conf($cref);
	print '<font color="#00aa00" size=4>'.__("Configuration globale modifie")."</font>\n";
    }
}

if (defined $cref->{"access file"})
{
    if ($param)
    {
	$param .= '&disable=1';
    }
    else
    {
	$param = 'disable=1';
    }
    $str = __("Dsactiver le contrle d'accs");
    print '<h3><a href="access.cgi?'.$param.'"><img src="images/alarm.gif" border=0 alt="'.$str.'" title="'.$str.'"></a> '.$title4."</h3>\n";
}
else
{
    if ($param)
    {
	$param .= '&enable=1';
    }
    else
    {
	$param = 'enable=1';
    }
    $str = __("Activer le contrle d'accs");
    print '<h3><a href="access.cgi?'.$param.'"><img src="images/alarm2.gif" border=0 alt="'.$str.'" title="'.$str.'"></a> '.$title4."</h3>\n";
}

print "<form method=post>\n";
if (defined $cref->{"access file"})
{
    print '<textarea name="access file" rows=10 cols=40>';
    print $cref->{"access file"};
    print "</textarea>\n";
}
print "<p>\n";
if ($q->param("disable"))
{
    print '<input type="submit" name="delaccess" value="'.__("Valider").'">'."\n";
}
elsif (defined $cref->{"access file"})
{
    print '<input type="submit" name="modify" value="'.__("Valider").'">'."\n";
    print '<input type="reset" value="'.__("Rinitialiser").'">'."\n";
}
if ($user)
{
    print '<input type="hidden" name="user" value="'.$user.'">'."\n";
}
elsif ($group)
{
    print '<input type="hidden" name="group" value="'.$group.'">'."\n";
}
print "</form>\n";

cw_footer();
